diff --git a/src/mongo/db/pipeline/document_source_queue.cpp b/src/mongo/db/pipeline/document_source/document_source_queue.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_queue.cpp
rename to src/mongo/db/pipeline/document_source/document_source_queue.cpp
index 12b8157117..44750f438c 100644
--- a/src/mongo/db/pipeline/document_source_queue.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_queue.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_queue.h"
+#include "mongo/db/pipeline/document_source/document_source_queue.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_queue.h b/src/mongo/db/pipeline/document_source/document_source_queue.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_queue.h
rename to src/mongo/db/pipeline/document_source/document_source_queue.h
index 4c91abdf44..670c4b7c1f 100644
--- a/src/mongo/db/pipeline/document_source_queue.h
+++ b/src/mongo/db/pipeline/document_source/document_source_queue.h
@@ -31,7 +31,7 @@
 
 #include <deque>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_redact.cpp b/src/mongo/db/pipeline/document_source/document_source_redact.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_redact.cpp
rename to src/mongo/db/pipeline/document_source/document_source_redact.cpp
index eaefcdf672..4b41b239a6 100644
--- a/src/mongo/db/pipeline/document_source_redact.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_redact.cpp
@@ -29,15 +29,15 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_redact.h"
+#include "mongo/db/pipeline/document_source/document_source_redact.h"
 
 #include <boost/optional.hpp>
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_redact.h b/src/mongo/db/pipeline/document_source/document_source_redact.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_redact.h
rename to src/mongo/db/pipeline/document_source/document_source_redact.h
index 10fcfc14f6..5dddb33c17 100644
--- a/src/mongo/db/pipeline/document_source_redact.h
+++ b/src/mongo/db/pipeline/document_source/document_source_redact.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_redact_test.cpp b/src/mongo/db/pipeline/document_source/document_source_redact_test.cpp
similarity index 94%
rename from src/mongo/db/pipeline/document_source_redact_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_redact_test.cpp
index 95d001e4da..dae287b1c8 100644
--- a/src/mongo/db/pipeline/document_source_redact_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_redact_test.cpp
@@ -33,9 +33,9 @@
 #include "mongo/bson/bsonobj.h"
 #include "mongo/bson/bsonobjbuilder.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_redact.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_redact.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_replace_root.cpp b/src/mongo/db/pipeline/document_source/document_source_replace_root.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_replace_root.cpp
rename to src/mongo/db/pipeline/document_source/document_source_replace_root.cpp
index 084d7398fb..271a6e35ca 100644
--- a/src/mongo/db/pipeline/document_source_replace_root.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_replace_root.cpp
@@ -29,13 +29,13 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
 
 #include <boost/smart_ptr/intrusive_ptr.hpp>
 
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/document_source_replace_root_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root_gen.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_replace_root.h b/src/mongo/db/pipeline/document_source/document_source_replace_root.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_replace_root.h
rename to src/mongo/db/pipeline/document_source/document_source_replace_root.h
index e0d8482d55..e9a861deac 100644
--- a/src/mongo/db/pipeline/document_source_replace_root.h
+++ b/src/mongo/db/pipeline/document_source/document_source_replace_root.h
@@ -30,8 +30,8 @@
 #pragma once
 
 #include "mongo/db/exec/document_value/document.h"
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_replace_root_test.cpp b/src/mongo/db/pipeline/document_source/document_source_replace_root_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_replace_root_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_replace_root_test.cpp
index 0397784b7f..ebfe3f8e57 100644
--- a/src/mongo/db/pipeline/document_source_replace_root_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_replace_root_test.cpp
@@ -37,8 +37,8 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_sample.cpp b/src/mongo/db/pipeline/document_source/document_source_sample.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_sample.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sample.cpp
index 57d5661c38..6e1474844b 100644
--- a/src/mongo/db/pipeline/document_source_sample.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sample.cpp
@@ -29,12 +29,12 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_sample.h"
+#include "mongo/db/pipeline/document_source/document_source_sample.h"
 
 #include "mongo/db/client.h"
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
diff --git a/src/mongo/db/pipeline/document_source_sample.h b/src/mongo/db/pipeline/document_source/document_source_sample.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_sample.h
rename to src/mongo/db/pipeline/document_source/document_source_sample.h
index 7dd31db3c4..b767e416cb 100644
--- a/src/mongo/db/pipeline/document_source_sample.h
+++ b/src/mongo/db/pipeline/document_source/document_source_sample.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_sample_from_random_cursor.cpp b/src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_sample_from_random_cursor.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.cpp
index 1105966e3a..a551dc9096 100644
--- a/src/mongo/db/pipeline/document_source_sample_from_random_cursor.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.cpp
@@ -31,14 +31,14 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_sample_from_random_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.h"
 
 #include <boost/math/distributions/beta.hpp>
 
 #include "mongo/db/client.h"
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/logv2/log.h"
 
diff --git a/src/mongo/db/pipeline/document_source_sample_from_random_cursor.h b/src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_sample_from_random_cursor.h
rename to src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.h
index 6552148815..b69fc5f6cd 100644
--- a/src/mongo/db/pipeline/document_source_sample_from_random_cursor.h
+++ b/src/mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.h
@@ -30,7 +30,7 @@
 #pragma once
 
 #include "mongo/db/exec/document_value/value_comparator.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_sample_test.cpp b/src/mongo/db/pipeline/document_source/document_source_sample_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_sample_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sample_test.cpp
index 68cd93c469..47264c7a43 100644
--- a/src/mongo/db/pipeline/document_source_sample_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sample_test.cpp
@@ -37,9 +37,9 @@
 #include "mongo/bson/bsonobjbuilder.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sample.h"
-#include "mongo/db/pipeline/document_source_sample_from_random_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sample.h"
+#include "mongo/db/pipeline/document_source/document_source_sample_from_random_cursor.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/unittest/death_test.h"
 #include "mongo/unittest/unittest.h"
diff --git a/src/mongo/db/pipeline/document_source_sequential_document_cache.cpp b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_sequential_document_cache.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.cpp
index 74256f4147..0cd5dcb64b 100644
--- a/src/mongo/db/pipeline/document_source_sequential_document_cache.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.cpp
@@ -29,9 +29,9 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_sequential_document_cache.h"
+#include "mongo/db/pipeline/document_source/document_source_sequential_document_cache.h"
 
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_sequential_document_cache.h b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_sequential_document_cache.h
rename to src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.h
index 355a7d3437..32f97f4f4b 100644
--- a/src/mongo/db/pipeline/document_source_sequential_document_cache.h
+++ b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/sequential_document_cache.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_sequential_document_cache_test.cpp b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache_test.cpp
similarity index 95%
rename from src/mongo/db/pipeline/document_source_sequential_document_cache_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sequential_document_cache_test.cpp
index d4480ca7c5..76fd4d9ad6 100644
--- a/src/mongo/db/pipeline/document_source_sequential_document_cache_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sequential_document_cache_test.cpp
@@ -35,8 +35,8 @@
 #include "mongo/bson/bsonobj.h"
 #include "mongo/bson/json.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sequential_document_cache.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sequential_document_cache.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_set_window_fields.cpp b/src/mongo/db/pipeline/document_source/document_source_set_window_fields.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_set_window_fields.cpp
rename to src/mongo/db/pipeline/document_source/document_source_set_window_fields.cpp
index 1e3f549edb..ede7aff5a5 100644
--- a/src/mongo/db/pipeline/document_source_set_window_fields.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_set_window_fields.cpp
@@ -31,11 +31,11 @@
 
 #include "mongo/db/exec/add_fields_projection_executor.h"
 #include "mongo/db/matcher/expression_algo.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_project.h"
-#include "mongo/db/pipeline/document_source_set_window_fields.h"
-#include "mongo/db/pipeline/document_source_set_window_fields_gen.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/query/query_knobs_gen.h"
 #include "mongo/db/query/sort_pattern.h"
diff --git a/src/mongo/db/pipeline/document_source_set_window_fields.h b/src/mongo/db/pipeline/document_source/document_source_set_window_fields.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_set_window_fields.h
rename to src/mongo/db/pipeline/document_source/document_source_set_window_fields.h
index f854de9265..c27e1b7686 100644
--- a/src/mongo/db/pipeline/document_source_set_window_fields.h
+++ b/src/mongo/db/pipeline/document_source/document_source_set_window_fields.h
@@ -29,11 +29,10 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_set_window_fields_gen.h"
-#include "mongo/db/pipeline/field_path.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields_gen.h"
 #include "mongo/db/pipeline/memory_usage_tracker.h"
 #include "mongo/db/pipeline/window_function/partition_iterator.h"
 #include "mongo/db/pipeline/window_function/window_bounds.h"
diff --git a/src/mongo/db/pipeline/document_source_set_window_fields_test.cpp b/src/mongo/db/pipeline/document_source/document_source_set_window_fields_test.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_set_window_fields_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_set_window_fields_test.cpp
index 287497db44..d7b04bdf2c 100644
--- a/src/mongo/db/pipeline/document_source_set_window_fields_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_set_window_fields_test.cpp
@@ -35,9 +35,9 @@
 #include "mongo/db/exec/document_value/document_comparator.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_set_window_fields.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_set_window_fields.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_single_document_transformation.cpp b/src/mongo/db/pipeline/document_source/document_source_single_document_transformation.cpp
similarity index 94%
rename from src/mongo/db/pipeline/document_source_single_document_transformation.cpp
rename to src/mongo/db/pipeline/document_source/document_source_single_document_transformation.cpp
index c72c338ab9..2b36cd0125 100644
--- a/src/mongo/db/pipeline/document_source_single_document_transformation.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_single_document_transformation.cpp
@@ -29,15 +29,15 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
 
 #include <boost/smart_ptr/intrusive_ptr.hpp>
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_skip.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_skip.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_single_document_transformation.h b/src/mongo/db/pipeline/document_source/document_source_single_document_transformation.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_single_document_transformation.h
rename to src/mongo/db/pipeline/document_source/document_source_single_document_transformation.h
index 958e39ad5f..1ea9e7398e 100644
--- a/src/mongo/db/pipeline/document_source_single_document_transformation.h
+++ b/src/mongo/db/pipeline/document_source/document_source_single_document_transformation.h
@@ -31,7 +31,7 @@
 
 #include <type_traits>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/transformer_interface.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_skip.cpp b/src/mongo/db/pipeline/document_source/document_source_skip.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source_skip.cpp
rename to src/mongo/db/pipeline/document_source/document_source_skip.cpp
index 7fa58be38e..eadcb80d7c 100644
--- a/src/mongo/db/pipeline/document_source_skip.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_skip.cpp
@@ -29,13 +29,13 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_skip.h"
+#include "mongo/db/pipeline/document_source/document_source_skip.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/util/str.h"
diff --git a/src/mongo/db/pipeline/document_source_skip.h b/src/mongo/db/pipeline/document_source/document_source_skip.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_skip.h
rename to src/mongo/db/pipeline/document_source/document_source_skip.h
index 89dbeb95b1..4ec13722a1 100644
--- a/src/mongo/db/pipeline/document_source_skip.h
+++ b/src/mongo/db/pipeline/document_source/document_source_skip.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_skip_test.cpp b/src/mongo/db/pipeline/document_source/document_source_skip_test.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_skip_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_skip_test.cpp
index 1de0df0232..1a5bede7f9 100644
--- a/src/mongo/db/pipeline/document_source_skip_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_skip_test.cpp
@@ -32,8 +32,8 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_skip.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_skip.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_sort.cpp b/src/mongo/db/pipeline/document_source/document_source_sort.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_sort.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sort.cpp
index 2b01f416e5..c663d8dbbe 100644
--- a/src/mongo/db/pipeline/document_source_sort.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sort.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 
 #include <algorithm>
 
@@ -37,7 +37,7 @@
 #include "mongo/db/exec/document_value/document_comparator.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/pipeline/skip_and_limit.h"
diff --git a/src/mongo/db/pipeline/document_source_sort.h b/src/mongo/db/pipeline/document_source/document_source_sort.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_sort.h
rename to src/mongo/db/pipeline/document_source/document_source_sort.h
index 622641bbb9..d5ded5d437 100644
--- a/src/mongo/db/pipeline/document_source_sort.h
+++ b/src/mongo/db/pipeline/document_source/document_source_sort.h
@@ -31,9 +31,9 @@
 
 #include "mongo/db/exec/sort_executor.h"
 #include "mongo/db/index/sort_key_generator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/query/query_knobs_gen.h"
 #include "mongo/db/query/sort_pattern.h"
 #include "mongo/db/sorter/sorter.h"
diff --git a/src/mongo/db/pipeline/document_source_sort_by_count.cpp b/src/mongo/db/pipeline/document_source/document_source_sort_by_count.cpp
similarity index 94%
rename from src/mongo/db/pipeline/document_source_sort_by_count.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sort_by_count.cpp
index d35ec06f33..bf5e95f156 100644
--- a/src/mongo/db/pipeline/document_source_sort_by_count.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sort_by_count.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_sort_by_count.h"
+#include "mongo/db/pipeline/document_source/document_source_sort_by_count.h"
 
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
diff --git a/src/mongo/db/pipeline/document_source_sort_by_count.h b/src/mongo/db/pipeline/document_source/document_source_sort_by_count.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_sort_by_count.h
rename to src/mongo/db/pipeline/document_source/document_source_sort_by_count.h
index 00493716f1..b73e4a0d2a 100644
--- a/src/mongo/db/pipeline/document_source_sort_by_count.h
+++ b/src/mongo/db/pipeline/document_source/document_source_sort_by_count.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_sort_by_count_test.cpp b/src/mongo/db/pipeline/document_source/document_source_sort_by_count_test.cpp
similarity index 95%
rename from src/mongo/db/pipeline/document_source_sort_by_count_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sort_by_count_test.cpp
index d4ab7f15c5..b13109c32a 100644
--- a/src/mongo/db/pipeline/document_source_sort_by_count_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sort_by_count_test.cpp
@@ -39,10 +39,10 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/document_source_sort_by_count.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_sort_by_count.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_sort_test.cpp b/src/mongo/db/pipeline/document_source/document_source_sort_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_sort_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_sort_test.cpp
index 980fc537f9..65fa8e9a55 100644
--- a/src/mongo/db/pipeline/document_source_sort_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_sort_test.cpp
@@ -42,8 +42,8 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/unittest/temp_dir.h"
 #include "mongo/unittest/unittest.h"
diff --git a/src/mongo/db/pipeline/document_source_tee_consumer.cpp b/src/mongo/db/pipeline/document_source/document_source_tee_consumer.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_tee_consumer.cpp
rename to src/mongo/db/pipeline/document_source/document_source_tee_consumer.cpp
index 608f1c46f0..c0da29094c 100644
--- a/src/mongo/db/pipeline/document_source_tee_consumer.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_tee_consumer.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_tee_consumer.h"
+#include "mongo/db/pipeline/document_source/document_source_tee_consumer.h"
 
 #include <boost/intrusive_ptr.hpp>
 #include <boost/optional.hpp>
diff --git a/src/mongo/db/pipeline/document_source_tee_consumer.h b/src/mongo/db/pipeline/document_source/document_source_tee_consumer.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_tee_consumer.h
rename to src/mongo/db/pipeline/document_source/document_source_tee_consumer.h
index 0e7d6d5a96..e9978955d9 100644
--- a/src/mongo/db/pipeline/document_source_tee_consumer.h
+++ b/src/mongo/db/pipeline/document_source/document_source_tee_consumer.h
@@ -32,7 +32,7 @@
 #include <boost/intrusive_ptr.hpp>
 #include <boost/optional.hpp>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/tee_buffer.h"
 
diff --git a/src/mongo/db/pipeline/document_source_test_optimizations.h b/src/mongo/db/pipeline/document_source/document_source_test_optimizations.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_test_optimizations.h
rename to src/mongo/db/pipeline/document_source/document_source_test_optimizations.h
index 57f92f37f0..5d89e0b019 100644
--- a/src/mongo/db/pipeline/document_source_test_optimizations.h
+++ b/src/mongo/db/pipeline/document_source/document_source_test_optimizations.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 
 namespace mongo {
